local t = TRCLOOT


local inventoryToScan = {1,3,5,8,10,15} --head,should,chest,legs,gloves,cloak


--[[
-- TODO
-- TODO
-- TODO
-- TODO
-- TODO
-- Split bestTier per tier and only report that one when sending it over
]]--





t.tierIDs = {
   -----------
   --  T19  --
   -----------
   
   [143575] = { -- T19 Prot Helm
      ["SHAMAN"] = 138343,
      ["WARRIOR"] = 138357,
      ["MONK"] = 138331,
      ["HUNTER"] = 138342,
      ["tier"] = 19
   },
   [143565] = { -- T19 Conq Helm
      ["DEMONHUNTER"] = 138378,
      ["PALADIN"] = 138356,
      ["PRIEST"] = 138313,
      ["WARLOCK"] = 138314,
      ["tier"] = 19
   },
   [143568] = { -- T19 Vanq Helm
      ["ROGUE"] = 138332,
      ["DRUID"] = 138330,
      ["DEATHKNIGHT"] = 138355,
      ["MAGE"] = 138312,
      ["tier"] = 19
   },
   
   
   [143576] = { -- T19 Prot Shoulders
      ["SHAMAN"] = 138348,
      ["WARRIOR"] = 138363,
      ["MONK"] = 138337,
      ["HUNTER"] = 138347,
      ["tier"] = 19
   },
   [143566] = { -- T19 Conq Shoulders
      ["DEMONHUNTER"] = 138380,
      ["PALADIN"] = 138362,
      ["PRIEST"] = 138322,
      ["WARLOCK"] = 138323,
      ["tier"] = 19
   },
   [143570] = { -- T19 Vanq Shoulders
      ["ROGUE"] = 138338,
      ["DRUID"] = 138336,
      ["DEATHKNIGHT"] = 138361,
      ["MAGE"] = 138321,
      ["tier"] = 19
   },
   
   
   [143579] = { -- T19 Prot Cloak
      ["SHAMAN"] = 138372,
      ["WARRIOR"] = 138374,
      ["MONK"] = 138367,
      ["HUNTER"] = 138368,
      ["tier"] = 19
   },
   [143577] = { -- T19 Conq Cloak
      ["DEMONHUNTER"] = 138375,
      ["PALADIN"] = 138369,
      ["PRIEST"] = 138370,
      ["WARLOCK"] = 138373,
      ["tier"] = 19
   },
   [143578] = { -- T19 Vanq Cloak
      ["ROGUE"] = 138371,
      ["DRUID"] = 138366,
      ["DEATHKNIGHT"] = 138364,
      ["MAGE"] = 138365,   
      ["tier"] = 19
   },
   
   
   [143572] = { -- T19 Prot Chest
      ["SHAMAN"] = 138346,
      ["WARRIOR"] = 138351,
      ["MONK"] = 138325,
      ["HUNTER"] = 138339,
      ["tier"] = 19
   },
   [143562] = { -- T19 Conq Chest
      ["DEMONHUNTER"] = 138376,
      ["PALADIN"] = 138350,
      ["PRIEST"] = 138319,
      ["WARLOCK"] = 138320,
      ["tier"] = 19
   },
   [143571] = { -- T19 Vanq Chest
      ["ROGUE"] = 138326,
      ["DRUID"] = 138324,
      ["DEATHKNIGHT"] = 138349,
      ["MAGE"] = 138318,
      ["tier"] = 19
   },
   
   
   [143573] = { -- T19 Prot Gloves
      ["SHAMAN"] = 138341,
      ["WARRIOR"] = 138354,
      ["MONK"] = 138328,
      ["HUNTER"] = 138340,
      ["tier"] = 19
   },
   [143563] = { -- T19 Conq Gloves
      ["DEMONHUNTER"] = 138377,
      ["PALADIN"] = 138353,
      ["PRIEST"] = 138310,
      ["WARLOCK"] = 138311,
      ["tier"] = 19
   },
   [143567] = { -- T19 Vanq Gloves
      ["ROGUE"] = 138329,
      ["DRUID"] = 138327,
      ["DEATHKNIGHT"] = 138352,
      ["MAGE"] = 138309,
      ["tier"] = 19
   },
   
   
   [143574] = { -- T19 Prot Legs
      ["SHAMAN"] = 138345,
      ["WARRIOR"] = 138360,
      ["MONK"] = 138334,
      ["HUNTER"] = 138344,
      ["tier"] = 19
   },
   [143564] = { -- T19 Conq Legs
      ["DEMONHUNTER"] = 138379,
      ["PALADIN"] = 138359,
      ["PRIEST"] = 138316,
      ["WARLOCK"] = 138317,
      ["tier"] = 19
   },
   [143569] = { -- T19 Vanq Legs
      ["ROGUE"] = 138335,
      ["DRUID"] = 138333,
      ["DEATHKNIGHT"] = 138358,
      ["MAGE"] = 138315,
      ["tier"] = 19
   },
   
}


t.generateTier = function(itemId, bonusId, specId)
   local item = select(2, GetItemInfo(itemId))

   -- If the item was not in cache, we must return nil
   if not item then
       return nil
   end
   
   -- Split the item string, insert pieces in list
   local l = {}
   for t in item:gmatch("([^:]*):?") do
      table.insert(l, t)
   end
   
   l[#l] = nil

   if specId then
       l[11] = specId
   end
   
   
   -- Insert the new upgradeID
   if bonusId ~= ""then
       l[14] = "1"
       l[15] = bonusId
   end
   
   
   -- Join and return 
   return table.concat(l, ":")
end


t.classInToken = function(class, token) 

   local id = tonumber((select(2, strsplit(":", token))))
   if t.tierIDs[tonumber(id)][class] then
       return true
   else
       return false
   end
end

t.getTierFromToken = function(token, class, specId)   

   
   local id = tonumber((select(2, strsplit(":", token))))
   local bonus1 = tonumber((select(15, strsplit(":", token))))
   
   local itemBonus = ""
   if bonus1 == nil then -- normal
      itemBonus = ""
   elseif bonus1 == 570 then -- hc
      itemBonus = "3516"
   elseif bonus1 == 569 then -- mythic
      itemBonus = "3518"
   end
   
   
   local tokenIds = t.tierIDs[tonumber(id)]
   if tokenIds == nil then
      return nil
   end
   
   
   local itemId = tokenIds[class]
   if itemId == nil then
      return nil
   end
   
   
   return t.generateTier(itemId, itemBonus, specId)
   
end

local storeItemIfTier = function(item)
   local itemID = TRCLOOT.getItemID(item)

   if t.tierWatchlist and t.tierWatchlist[itemID] then
       local bestTier = t.getVar("bestTier")
       local info = {GetItemInfo(item)}
       local ilvl = info[4]
       local slot = info[9]
       if ilvl and ilvl >= (bestTier[itemID] or -1) then
           bestTier[slot] = ilvl
       end
   end
end

t.scanInventoryForTier = function()
   for _,inventorySlot in pairs(inventoryToScan) do
      local inventoryItem = GetInventoryItemLink("player", inventorySlot)
      if inventoryItem then
         storeItemIfTier(inventoryItem)
      end
   end
   
end

t.scanBagsForTier = function()
   for bag=0, 5 do
      for slot=0, GetContainerNumSlots(bag) do
         local bagLink = GetContainerItemLink(bag, slot)
         if bagLink then
            storeItemIfTier(bagLink)
         end
      end
   end
end

t.scanBankForTier = function()
   
   -- Main bank
   for slot=0, GetContainerNumSlots(-1) do
      local bagLink = GetContainerItemLink(-1, slot)
      if bagLink then
         storeItemIfTier(bagLink)
      end
   end
   
   for bag=5, 5+GetNumBankSlots() do
      for slot=0, GetContainerNumSlots(bag) do
         local bagLink = GetContainerItemLink(bag, slot)
         if bagLink then
            storeItemIfTier(bagLink)
         end
      end
   end
end
